## ros-foxy-rc-genicam-api 2.6.1

=== doc/CMakeLists.txt ===
# add a target to generate API documentation with Doxygen
find_package(Doxygen)
if(DOXYGEN_FOUND)
  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile @ONLY)
  add_custom_target(doc
      ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
      WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
      COMMENT "Generating API documentation with Doxygen" VERBATIM
  )
else(DOXYGEN_FOUND)
  add_custom_target(doc
      echo "Can't build docs without doxygen installed." && exit 1
      WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
      COMMENT "Generating API documentation with Doxygen" VERBATIM
  )
endif(DOXYGEN_FOUND)

=== tools/CMakeLists.txt ===
# This file is part of the rc_genicam_api package.
#
# Copyright (c) 2017 Roboception GmbH
# All rights reserved
#
# Author: Heiko Hirschmueller
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
# 1. Redistributions of source code must retain the above copyright notice,
# this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above copyright notice,
# this list of conditions and the following disclaimer in the documentation
# and/or other materials provided with the distribution.
#
# 3. Neither the name of the copyright holder nor the names of its contributors
# may be used to endorse or promote products derived from this software without
# specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.

project(tools CXX)

# build programs

add_executable(gc_info gc_info.cc)
target_link_libraries(gc_info
  PRIVATE
      ${PROJECT_NAMESPACE}::rc_genicam_api_static)
target_compile_options(gc_info PRIVATE $<$<CXX_COMPILER_ID:GNU>:-Wall>)

add_executable(gc_config gc_config.cc)
target_link_libraries(gc_config
  PRIVATE
    ${PROJECT_NAMESPACE}::rc_genicam_api_static)
target_compile_options(gc_config PRIVATE $<$<CXX_COMPILER_ID:GNU>:-Wall>)

add_executable(gc_stream gc_stream.cc)
target_link_libraries(gc_stream
  PRIVATE
    ${PROJECT_NAMESPACE}::rc_genicam_api_static)
target_compile_options(gc_stream PRIVATE $<$<CXX_COMPILER_ID:GNU>:-Wall>)

if (UNIX)
  find_package(Threads REQUIRED)
  target_link_libraries(gc_stream
    PRIVATE
      ${CMAKE_THREAD_LIBS_INIT})
endif ()

add_executable(gc_pointcloud gc_pointcloud.cc)
target_link_libraries(gc_pointcloud
  PRIVATE
    ${PROJECT_NAMESPACE}::rc_genicam_api_static)
target_compile_options(gc_pointcloud PRIVATE $<$<CXX_COMPILER_ID:GNU>:-Wall>)

add_executable(gc_file gc_file.cc)
target_link_libraries(gc_file
  PRIVATE
      ${PROJECT_NAMESPACE}::rc_genicam_api_static)
target_compile_options(gc_file PRIVATE $<$<CXX_COMPILER_ID:GNU>:-Wall>)

# install tools

install(TARGETS gc_info
    EXPORT PROJECTTargets
    COMPONENT bin
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
install(TARGETS gc_config
    EXPORT PROJECTTargets
    COMPONENT bin
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
install(TARGETS gc_stream
    EXPORT PROJECTTargets
    COMPONENT bin
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
install(TARGETS gc_pointcloud
    EXPORT PROJECTTargets
    COMPONENT bin
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
install(TARGETS gc_file
    EXPORT PROJECTTargets
    COMPONENT bin
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

=== debian/changelog ===
ros-foxy-rc-genicam-api (2.6.1-1focal) focal; urgency=high

  * Fixed resetting of systems so that setSystemsPath() can be called again
  * Report reason if loading of producer fails
  * Fixed compiling under Windows
  * Fixed reading registers with size that is less than the requested size
  * Added convenience functions for loading and storing data on the camera via GenICam file interface

 -- Felix Ruess <felix.ruess@roboception.de>  Sun, 08 Jan 2023 23:00:00 -0000

ros-foxy-rc-genicam-api (2.6.0-1focal) focal; urgency=high

  * Upgraded GenAPI to version 3.4
  * Changed gc_file to read and write in blocks of 512 bytes and made FileSize parameter optional

 -- Felix Ruess <felix.ruess@roboception.de>  Tue, 08 Nov 2022 23:00:00 -0000

ros-foxy-rc-genicam-api (2.5.17-1focal) focal; urgency=high

  * Added building for Jammy
  * Added possibility to specify GenICam parameters on the command line of gc_pointcloud tool
  * README: change grep for newer netstat versions

 -- Felix Ruess <felix.ruess@roboception.de>  Wed, 12 Oct 2022 22:00:00 -0000

ros-foxy-rc-genicam-api (2.5.16-1focal) focal; urgency=high

  * Added CI build pipelines for ARM64
  * net_perf_check.sh use first default interface
  * Show enum options even if WriteOnly

 -- Felix Ruess <felix.ruess@roboception.de>  Sat, 28 May 2022 22:00:00 -0000

ros-foxy-rc-genicam-api (2.5.14-1focal) focal; urgency=high

  * Install licenses of included binaries
  * Reporting interface id instead of display name in output of gc_info -s

 -- Felix Ruess <felix.ruess@roboception.de>  Tue, 01 Feb 2022 23:00:00 -0000

ros-foxy-rc-genicam-api (2.5.13-1focal) focal; urgency=high

  * Added parameter '-s' to gc_info for getting a short list of discovered devices
  * Fixed Windows build script

 -- Felix Ruess <felix.ruess@roboception.de>  Sun, 30 Jan 2022 23:00:00 -0000

ros-foxy-rc-genicam-api (2.5.12-1focal) focal; urgency=high

  * Imporved Windows build script for compiling with libpng
  * Fixed some issues when compiling under Windows

 -- Felix Ruess <felix.ruess@roboception.de>  Fri, 22 Oct 2021 22:00:00 -0000

ros-foxy-rc-genicam-api (2.5.11-1focal) focal; urgency=high

  * Fixed getting buffers with chunk data from Basler ace2 USB cameras

 -- Felix Ruess <felix.ruess@roboception.de>  Mon, 04 Oct 2021 22:00:00 -0000

ros-foxy-rc-genicam-api (2.5.10-1focal) focal; urgency=high

  * Make system, interface, device and stream ignore closing already closed objects

 -- Felix Ruess <felix.ruess@roboception.de>  Thu, 30 Sep 2021 22:00:00 -0000

ros-foxy-rc-genicam-api (2.5.9-1focal) focal; urgency=high

  * Improved measuring of buffers per second in gc_stream
  * Do not show latency in gc_stream -t if PTP is turned off

 -- Felix Ruess <felix.ruess@roboception.de>  Thu, 30 Sep 2021 22:00:00 -0000

ros-foxy-rc-genicam-api (2.5.8-1focal) focal; urgency=high

  * Added support for YUV422_8 and YCbCr422_8 pixel formats

 -- Felix Ruess <felix.ruess@roboception.de>  Wed, 08 Sep 2021 22:00:00 -0000

ros-foxy-rc-genicam-api (2.5.7-1focal) focal; urgency=high

  * Added possibility to specify the internal number of buffers to allocate
  * gc_file tool: Exit with error if file cannot be loaded

 -- Felix Ruess <felix.ruess@roboception.de>  Tue, 31 Aug 2021 22:00:00 -0000

ros-foxy-rc-genicam-api (2.5.6-1focal) focal; urgency=high

  * Changed ImageList::find with tolerance > 0 to return the closest within tolerance

 -- Felix Ruess <felix.ruess@roboception.de>  Sun, 01 Aug 2021 22:00:00 -0000

ros-foxy-rc-genicam-api (2.5.5-1focal) focal; urgency=high

  * Fixed rounding when converting between color and monochrome images
  * Reduce minimum number of buffers
  * Do not attach chunk data handler to incomplete buffer

 -- Felix Ruess <felix.ruess@roboception.de>  Tue, 27 Jul 2021 22:00:00 -0000

ros-foxy-rc-genicam-api (2.5.4-1focal) focal; urgency=high

  * Fixed reporting of operation status of gc_file tool

 -- Felix Ruess <felix.ruess@roboception.de>  Sat, 24 Jul 2021 22:00:00 -0000

ros-foxy-rc-genicam-api (2.5.3-1focal) focal; urgency=high

  * Added build script for Visual Studio
  * Added methods for getting region id and data purpose id from buffer
  * On Windows, also try to find producers in sub directories of current library
  * Fixed some compiler warnings
  * Improved error message when writing on cport fails
  * Fixed conversion from YCbCr411 format to Mono8 in convertImage() function
  * Improved error message when setting invalid enum
  * Added support for RGB8 color format in getColor() function

 -- Felix Ruess <felix.ruess@roboception.de>  Fri, 16 Jul 2021 22:00:00 -0000

ros-foxy-rc-genicam-api (2.5.2-1focal) focal; urgency=high

  * Added possibility for configuration of multiple Gev interfaces in gc_config
  * Fixed printing of Mac address in gc_info
  * Added method to stream object for checking the number of buffers available for grabbing
  * Treating missing parameters in Buffer as 0
  * Changed way how to define different path for locating producers
  * Added possibility to discover producers in non-default locations and ignoring a specific producer
  * Added possibility to store xml file with gc_info with original name

 -- Felix Ruess <felix.ruess@roboception.de>  Mon, 05 Jul 2021 22:00:00 -0000

ros-foxy-rc-genicam-api (2.5.1-1focal) focal; urgency=high

  * Fixed compile problems under Windows
  * Fixed using wrong pointer in method Stream::getTLType()
  * Readme: Add link to release page
  * Removing redundent specification of namespace in some source files

 -- Felix Ruess <felix.ruess@roboception.de>  Mon, 15 Mar 2021 23:00:00 -0000

ros-foxy-rc-genicam-api (2.5.0-1focal) focal; urgency=high

  * Upgrading GenICam reference implementation to version 3.3
  * Added support for storing images of format RGB8 and BayerXX8
  * Increasing discover timeout from 100 ms to 1 s, which is necessary for some cameras
  * Resetting chunk adapter in gc_stream if user explicitely disables chunk data


=== debian/control ===
Source: ros-foxy-rc-genicam-api
Section: misc
Priority: optional
Maintainer: Felix Ruess <felix.ruess@roboception.de>
Build-Depends: debhelper (>= 9.0.0), cmake, libpng-dev, libusb-1.0-0, ros-foxy-ros-workspace
Homepage: http://wiki.ros.org/rc_genicam_api
Standards-Version: 3.9.2

Package: ros-foxy-rc-genicam-api
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libpng-dev, libusb-1.0-0, ros-foxy-ros-workspace
Description: GenICam/GigE Vision Convenience Layer.
 This package combines the Roboception convenience layer for images with the GenICam reference implementation and a GigE Vision transport layer. It is a self contained package that permits configuration and image streaming of GenICam / GigE Vision 2.0 compatible cameras like the Roboception rc_visard. This package also provides some tools that can be called from the command line for discovering cameras, changing their configuration and streaming images. Although the tools are meant to be useful when working in a shell or in a script, their main purpose is to serve as example on how to use the API for reading and setting parameters, streaming and synchronizing images. See LICENSE.md for licensing terms of the different parts.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/foxy/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

# Solve shlibdeps errors in REP136 packages that use GNUInstallDirs:
export DEB_HOST_MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/foxy" \
		-DCMAKE_PREFIX_PATH="/opt/ros/foxy" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-foxy-rc-genicam-api//opt/ros/foxy/lib/:$(CURDIR)/debian/ros-foxy-rc-genicam-api//opt/ros/foxy/lib/${DEB_HOST_MULTIARCH}

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_install
